#!/usr/bin/env python

import os, sys, base64

VERSIONEER_b64 = """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"""
newver = "0.18.2"


def main():
    if len(sys.argv) < 2:
        print("Usage: versioneer install")
        sys.exit(1)

    command = sys.argv[1]
    if command in ("version", "--version"):
        print("versioneer (installer) %s" % newver)
        sys.exit(0)

    if command != "install":
        print("Usage: versioneer install")
        sys.exit(1)

    v = base64.b64decode(VERSIONEER_b64.encode('ASCII'))
    if os.path.exists("versioneer.py"):
        for line in open("versioneer.py").readlines()[:5]:
            if line.startswith("# Version: "):
                oldver = line[len("# Version: "):].strip()
                if oldver != newver:
                    print("replacing old versioneer.py (%s)" % oldver)
                break
        else:
            print("overwriting existing versioneer.py")
    with open("versioneer.py", "wb") as f:
        f.write(v)
    print("versioneer.py (%s) installed into local tree" % newver)
    print("Now running 'versioneer.py setup' to install the generated files..")
    if " " in sys.executable:
        import subprocess  # Do not import unless absolutely necessary to avoid compatibility issues
        subprocess.call([sys.executable, "versioneer.py", "setup"])
    else:
        os.execl(sys.executable, sys.executable, "versioneer.py", "setup")

if __name__ == '__main__':
    main()
